/// <reference types="node" />
import { IService } from "../Service";
import { EventEmitter } from "events";
export interface IPermissionsServiceEventEmitter {
    on(event: "handlePermissionChange", listener: (changeEvent: Realm.Sync.ChangeEvent) => void): this;
    on(event: "handleUserSpecificManagementChange", listener: (changeEvent: Realm.Sync.ChangeEvent) => void): this;
}
export interface IPermissionChangeRequest {
    condition: Realm.Sync.PermissionCondition;
    realmPath: string;
    accessLevel: Realm.Sync.AccessLevel;
}
export declare class PermissionsService extends EventEmitter implements IPermissionsServiceEventEmitter, IService {
    private static MANAGEMENT_REALM_REGEX;
    private static ADMIN_REALM_REGEX;
    private adminRealm;
    private legacyWildcardPermissionRealm;
    private wildcardPermissionRealm;
    private logger;
    private server;
    private handleManagementChangeCallback;
    private handleAdminChangeCallback;
    private pendingHandlerCallbacks;
    private static extractPermission;
    private static ensureInTransaction;
    private static getPrimaryKey;
    private getManagementRealmForUserId;
    private getUserSpecificPermissionRealm;
    private start;
    private stopping;
    private stop;
    private onDemand;
    private applyPermissions;
    private unreflectPermissionIn;
    private reflectPermissionIn;
    private getUserByUserId;
    private getUserIdsWithMetadata;
    private grantReadOnlyAccessToWildcardPermissionRealm;
    private grantReadWriteOnLegacyUserPermissionRealms;
    private applyPermissionChangeInAdminRealm;
    private handleAdminRealmChange;
    private handleManagementRealmChange;
    private handleGNCallback;
    private handlePermissionOfferObject;
    private handlePermissionOfferResponseObject;
    private handlePermissionChangeObject;
    private validateUserIdCanChangePermissionsForPath;
}
