"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const semver = require("semver");
const ProcessUtil_1 = require("./ProcessUtil");
function checkEngine(packageJson = "../../package.json") {
    const version = require(packageJson).engines.node;
    if (!semver.satisfies(process.version, version)) {
        ProcessUtil_1.ProcessUtil.terminate({ success: false, message: `Required node version ${version} not satisfied with current version ${process.version}.` });
    }
}
exports.checkEngine = checkEngine;
//# sourceMappingURL=checkEngine.js.map