import { Realm } from "./realmUtil";
import * as superagent from "superagent";
export declare function Promisify<T>(callback: any, ...args: any[]): Promise<T>;
export declare class TimeoutError extends Error {
    ms: number;
    constructor(ms: number);
}
export declare function timeout<T>(promise: Promise<T>, ms: number): Promise<T>;
export declare function delay(ms: number): Promise<void>;
export declare function validateRealmPath(path: string, userId: string): string;
export declare function getUserIdFromRealmPath(path: string): string;
export declare function writeAsync(realm: Realm, callback: () => void): Promise<void>;
export declare function downloadAllServerChanges(realm: Realm): Promise<void>;
export declare function uploadAllLocalChanges(realm: Realm): Promise<void>;
export declare function convertHttpError(error: any): any;
export declare function waitAsync<T>(getter: () => T | Promise<T>, verifier?: (item: T) => boolean, timeout?: number, throwOnTimeout?: boolean): Promise<T>;
export declare function retryRequest(retries?: number, delay?: number, shouldRetry?: (response: superagent.Response) => boolean): superagent.Plugin;
export declare function isPartialPath(path: string): boolean;
export declare function extractPartialInfo(path: string): {
    partialIndex: number;
    isPartial: boolean;
    canonicalPath: string;
    customIdentifier: string;
    fullPath: string;
};
export declare function getValueIfResolved<T>(promise: Promise<T>): Promise<T | undefined>;
